Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/SelfTest/src/test.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/SelfTest/src/test.cpp	(revision 42)
@@ -43,4 +43,5 @@
    *********************************************************************/
   sc_clock                                 CLOCK ("clock", 1.0, 0.5);
+  sc_signal<Tcontrol_t>                    RESET;
   sc_signal<Tdata_t>                       DATA_IN  [param._nb_port];
   sc_signal<Tcontrol_t>                    ADDSUB   [param._nb_port];
@@ -53,7 +54,6 @@
   cout << "<" << name << "> Instanciation of _Counter" << endl;
  
- #if defined(STATISTICS) or defined(VHDL_TESTBENCH)
   (*(_Counter->in_CLOCK))        (CLOCK);
-#endif
+  (*(_Counter->in_NRESET))       (RESET);
 
   for (uint32_t i=0; i<param._nb_port; i++)
@@ -79,13 +79,13 @@
 
   sc_start(0);
-  _Counter->vhdl_testbench_label("Initialisation");
+
+  RESET.write(1);
+
   cout << "{"+toString(static_cast<uint32_t>(sc_simulation_time()))+"} Initialisation" << endl;
 
-  _Counter->vhdl_testbench_label("Loop of Test");
   cout << "{"+toString(static_cast<uint32_t>(sc_simulation_time()))+"} Loop of Test" << endl;
 
   for (uint32_t iteration=0; iteration<NB_ITERATION; iteration ++)
     {
-      _Counter->vhdl_testbench_label("Iteration "+toString(iteration));
       cout << "{" << static_cast<uint32_t>(sc_simulation_time()) << "} Itération " << iteration << endl;
       for (uint32_t i=0; i<param._nb_port; i++)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/include/Counter.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/include/Counter.h	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/include/Counter.h	(revision 42)
@@ -25,15 +25,12 @@
 #include "Behavioural/include/Vhdl.h"
 #endif
-#ifdef VHDL_TESTBENCH
-#include "Behavioural/include/Vhdl_Testbench.h"
-#endif
+#include "Behavioural/include/Component.h"
 
 using namespace std;
 
-namespace morpheo                    {
+namespace morpheo {
 namespace behavioural {
 namespace generic {
 namespace counter {
-
 
   class Counter 
@@ -55,7 +52,6 @@
 #endif
 
-#ifdef VHDL_TESTBENCH
-  private   : Vhdl_Testbench                 * _vhdl_testbench;
-#endif
+  public    : Component                      * _component;
+  private   : Interfaces                     * _interfaces;
 
 #ifdef SYSTEMC
@@ -63,5 +59,5 @@
     // Interface
   public    : SC_CLOCK                      *  in_CLOCK        ;
-
+  public    : SC_IN (Tcontrol_t)            *  in_NRESET       ;
   public    : SC_IN (Tdata_t)              **  in_COUNTER_DATA         ;
   public    : SC_IN (Tcontrol_t)           **  in_COUNTER_ADDSUB       ;
@@ -107,14 +103,12 @@
 #if VHDL				       
   public  : void     vhdl                      (void);
-  private : void     vhdl_port                 (Vhdl & vhdl);
-  private : void     vhdl_declaration          (Vhdl & vhdl);
-  private : void     vhdl_body                 (Vhdl & vhdl);
+  private : void     vhdl_port                 (Vhdl * & vhdl);
+  private : void     vhdl_declaration          (Vhdl * & vhdl);
+  private : void     vhdl_body                 (Vhdl * & vhdl);
 #endif					       
 					       
 #ifdef VHDL_TESTBENCH			       
-  private : void     vhdl_testbench_port       (void);
   private : void     vhdl_testbench_transition (void);
 #endif
-  public  : void     vhdl_testbench_label      (string label);
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter.cpp	(revision 42)
@@ -31,4 +31,8 @@
     log_printf(FUNC,Counter,"Counter","Begin");
 
+#ifdef SYSTEMC
+    allocation ();
+#endif
+
 #ifdef STATISTICS
     // Allocation of statistics
@@ -36,13 +40,4 @@
 			    param_statistics          ,
 			    param);
-#endif
-
-#ifdef VHDL_TESTBENCH
-    // Creation of a testbench
-    //  -> port
-    //  -> clock's signals
-    _vhdl_testbench = new Vhdl_Testbench (_name);
-    vhdl_testbench_port           ();
-    _vhdl_testbench->set_clock    ("in_CLOCK",false);
 #endif
 
@@ -53,6 +48,4 @@
 
 #ifdef SYSTEMC
-    allocation ();
-
     SC_METHOD (transition);
     dont_initialize ();
@@ -85,10 +78,4 @@
 #endif
 
-#ifdef VHDL_TESTBENCH
-    // generate the test bench
-    _vhdl_testbench->generate_file();
-    delete _vhdl_testbench;
-#endif
-
 #ifdef STATISTICS
     _stat->generate_file(statistics(0));
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_allocation.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_allocation.cpp	(revision 42)
@@ -21,23 +21,53 @@
     log_printf(FUNC,Counter,"allocation","Begin");
 
-#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
-    in_CLOCK  = new SC_CLOCK           ("in_CLOCK");
+    _component   = new Component ();
+
+    Entity * entity = _component->set_entity (_name     
+					     ,"Counter"  
+#ifdef POSITION
+					     ,COMBINATORY
 #endif
+					      );
+    
+    _interfaces = entity->set_interfaces();
 
-     in_COUNTER_DATA  = new SC_IN (Tdata_t)    * [_param._nb_port];
-     in_COUNTER_ADDSUB= new SC_IN (Tcontrol_t) * [_param._nb_port];
-    out_COUNTER_DATA  = new SC_OUT(Tdata_t)    * [_param._nb_port];
-    
-    for (uint32_t i=0; i<_param._nb_port; i++)
-      {
-	rename = " in_COUNTER_DATA_" +toString(i);
-	 in_COUNTER_DATA  [i] = new SC_IN (Tdata_t)    (rename.c_str());
+    // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    {
+      Interface * interface = _interfaces->set_interface(""
+#ifdef POSITION
+							 , IN  
+							 , SOUTH
+							 , "Generalist interface"
+#endif
+							 );
+      
+      in_CLOCK              = interface->set_signal_clk              ("clock" ,1,CLOCK_VHDL_NO);
+      in_NRESET             = interface->set_signal_in  <Tcontrol_t> ("nreset",1,RESET_VHDL_NO);
+    }
 
-	rename = " in_COUNTER_ADDSUB_"+toString(i);
-	 in_COUNTER_ADDSUB[i] = new SC_IN (Tcontrol_t) (rename.c_str());
-
-	rename = "out_COUNTER_DATA_" +toString(i);
-	out_COUNTER_DATA  [i] = new SC_OUT(Tdata_t)    (rename.c_str());
-      }
+    // ~~~~~[ Interface : "counter" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+     {
+        in_COUNTER_DATA  = new SC_IN (Tdata_t)    * [_param._nb_port];
+        in_COUNTER_ADDSUB= new SC_IN (Tcontrol_t) * [_param._nb_port];
+       out_COUNTER_DATA  = new SC_OUT(Tdata_t)    * [_param._nb_port];
+       
+       for (uint32_t i=0; i<_param._nb_port; i++)
+	 {
+	   Interface_fifo * interface = _interfaces->set_interface("counter_"+toString(i)
+#ifdef POSITION
+								   , IN  
+								   , SOUTH
+								   , "Counter interface"
+#endif
+								   );
+	   
+	    in_COUNTER_DATA   [i] = interface->set_signal_in  <Tdata_t   > ("data"  , _param._size_data);
+	    in_COUNTER_ADDSUB [i] = interface->set_signal_in  <Tcontrol_t> ("addsub", 1                );
+	   out_COUNTER_DATA   [i] = interface->set_signal_out <Tdata_t   > ("data"  , _param._size_data);
+	 }
+     }
+#ifdef POSITION
+    _component->generate_file();
+#endif
 
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_deallocation.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_deallocation.cpp	(revision 42)
@@ -19,19 +19,14 @@
     log_printf(FUNC,Counter,"deallocation","Begin");
 
-#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
-    delete in_CLOCK;
-#endif
+    delete     in_CLOCK;
+    delete     in_NRESET;
     
-    for (uint32_t i=0; i<_param._nb_port; i++)
-      {
-	delete  in_COUNTER_DATA  [i];
-	delete  in_COUNTER_ADDSUB[i];
-	delete out_COUNTER_DATA  [i];
-      }
-    delete  in_COUNTER_DATA  ;
-    delete  in_COUNTER_ADDSUB;
-    delete out_COUNTER_DATA  ;
+    delete []  in_COUNTER_DATA  ;
+    delete []  in_COUNTER_ADDSUB;
+    delete [] out_COUNTER_DATA  ;
     
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+
+    delete _component;
 
     log_printf(FUNC,Counter,"deallocation","End");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_genMealy.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_genMealy.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_genMealy.cpp	(revision 42)
@@ -1,4 +1,3 @@
 #ifdef SYSTEMC
-#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
 /*
  * $Id$
@@ -51,3 +50,2 @@
 }; // end namespace morpheo              
 #endif
-#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl.cpp	(revision 42)
@@ -19,7 +19,7 @@
   {
     log_printf(FUNC,Counter,"vhdl","Begin");
-    Vhdl vhdl (_name);
+    Vhdl * vhdl = new Vhdl (_name);
 
-    vhdl.set_library_work (_name + "_Pack");
+    vhdl->set_library_work (_name + "_Pack");
 
     vhdl_port        (vhdl);
@@ -27,5 +27,7 @@
     vhdl_body        (vhdl);
 
-    vhdl.generate_file();
+    vhdl->generate_file();
+
+    delete vhdl;
     log_printf(FUNC,Counter,"vhdl","End");
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl_body.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl_body.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl_body.cpp	(revision 42)
@@ -14,9 +14,8 @@
 namespace counter {
 
-
-  void Counter::vhdl_body (Vhdl & vhdl)
+  void Counter::vhdl_body (Vhdl * & vhdl)
   {
     log_printf(FUNC,Counter,"vhdl_body","Begin");
-    vhdl.set_body ("");
+    vhdl->set_body ("");
     
     for (uint32_t i=0; i<_param._nb_port; i++)
@@ -26,23 +25,23 @@
 	if (_param._size_data > 1)
 	  {
-	    counter_inc = "in_COUNTER_DATA_"+toString(i)+"+1";
-	    counter_dec = "in_COUNTER_DATA_"+toString(i)+"-1";
+	    counter_inc = "in_COUNTER_"+toString(i)+"_DATA+1";
+	    counter_dec = "in_COUNTER_"+toString(i)+"_DATA-1";
 	  }
 	else
 	  {
-	    counter_inc = "in_COUNTER_DATA_"+toString(i)+"+1";
-	    counter_dec = "in_COUNTER_DATA_"+toString(i)+"-1";
+	    counter_inc = "in_COUNTER_"+toString(i)+"_DATA+1";
+	    counter_dec = "in_COUNTER_"+toString(i)+"_DATA-1";
 	  }
 
-	vhdl.set_body ("out_COUNTER_DATA_"+toString(i)+" <=");
+	vhdl->set_body ("out_COUNTER_"+toString(i)+"_DATA <=");
 	if (_param._size_data > 1)
 	  {
-	    vhdl.set_body ("\tin_COUNTER_DATA_"+toString(i)+"+1 when in_COUNTER_ADDSUB_"+toString(i)+" = '1' and in_COUNTER_DATA_"+toString(i)+" < cst_max else");
-	    vhdl.set_body ("\tin_COUNTER_DATA_"+toString(i)+"-1 when in_COUNTER_ADDSUB_"+toString(i)+" = '0' and in_COUNTER_DATA_"+toString(i)+" > cst_min else");
-	    vhdl.set_body ("\tin_COUNTER_DATA_"+toString(i)+";");
+	    vhdl->set_body ("\tin_COUNTER_"+toString(i)+"_DATA+1 when in_COUNTER_"+toString(i)+"_ADDSUB = '1' and in_COUNTER_"+toString(i)+"_DATA < cst_max else");
+	    vhdl->set_body ("\tin_COUNTER_"+toString(i)+"_DATA-1 when in_COUNTER_"+toString(i)+"_ADDSUB = '0' and in_COUNTER_"+toString(i)+"_DATA > cst_min else");
+	    vhdl->set_body ("\tin_COUNTER_"+toString(i)+"_DATA;");
 	  }
 	else
 	  {
-	    vhdl.set_body ("\tin_COUNTER_ADDSUB_"+toString(i)+";");
+	    vhdl->set_body ("\tin_COUNTER_"+toString(i)+"_ADDSUB;");
 	  }
       }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl_declaration.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl_declaration.cpp	(revision 42)
@@ -15,5 +15,5 @@
 
 
-  void Counter::vhdl_declaration (Vhdl & vhdl)
+  void Counter::vhdl_declaration (Vhdl * & vhdl)
   {
     log_printf(FUNC,Counter,"vhdl_declaration","Begin");
@@ -21,6 +21,6 @@
     if (_param._size_data > 1)
       {
-	vhdl.set_constant ("cst_min",_param._size_data,std_logic_others(_param._size_data,0));
-	vhdl.set_constant ("cst_max",_param._size_data,std_logic_others(_param._size_data,1));
+	vhdl->set_constant ("cst_min",_param._size_data,std_logic_others(_param._size_data,0));
+	vhdl->set_constant ("cst_max",_param._size_data,std_logic_others(_param._size_data,1));
       }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl_port.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl_port.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl_port.cpp	(revision 42)
@@ -15,15 +15,10 @@
 
 
-  void Counter::vhdl_port (Vhdl & vhdl)
+  void Counter::vhdl_port (Vhdl * & vhdl)
   {
     log_printf(FUNC,Counter,"vhdl_port","Begin");
 
-    for (uint32_t i=0; i<_param._nb_port; i++)
-      {
-	vhdl.set_port (" in_COUNTER_DATA_"  +toString(i), IN, _param._size_data);
-	vhdl.set_port (" in_COUNTER_ADDSUB_"+toString(i), IN, 1                );
-	vhdl.set_port ("out_COUNTER_DATA_"  +toString(i),OUT, _param._size_data);
-      }
-    
+    _interfaces->set_port(vhdl);
+
     log_printf(FUNC,Counter,"vhdl_port","End");
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl_testbench_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl_testbench_transition.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Counter/src/Counter_vhdl_testbench_transition.cpp	(revision 42)
@@ -21,21 +21,5 @@
     sc_start(0);
 
-    // In order with file Counter_vhdl_testbench_port.cpp
-    // Warning : if a output depend of a subcomponent, take directly the port of subcomponent
-    // (because we have no control on the ordonnancer's policy)
-
-    for (uint32_t i=0; i<_param._nb_port; i++)
-      {
-	_vhdl_testbench->add_input (PORT_READ( in_COUNTER_DATA  [i]));
-	_vhdl_testbench->add_input (PORT_READ( in_COUNTER_ADDSUB[i]));
-	_vhdl_testbench->add_output(PORT_READ(out_COUNTER_DATA  [i]));
-      }
-    
-    // add_test :
-    //  - True  : the cycle must be compare with the output of systemC
-    //  - False : no test
-    _vhdl_testbench->add_test(true);
-
-    _vhdl_testbench->new_cycle (); // always at the end
+    _interfaces->testbench();
 
     log_printf(FUNC,Counter,"vhdl_testbench_transition","End");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/SelfTest/src/test.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/SelfTest/src/test.cpp	(revision 42)
@@ -94,5 +94,9 @@
     READ_VAL  [i] .write (0);
 
+  NRESET.write(0);
+
   sc_start(5);
+
+  NRESET.write(1);
 
   cout << "<" << name << "> Write the RegisterFile (no read)" << endl;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/RegisterFile_Monolithic.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/RegisterFile_Monolithic.h	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/RegisterFile_Monolithic.h	(revision 42)
@@ -23,9 +23,5 @@
 #include "Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/include/Statistics.h"
 #endif
-#ifdef POSITION
-#include "Behavioural/include/Position.h"
-#else
-#include "Behavioural/include/Interfaces.h"
-#endif
+#include "Behavioural/include/Component.h"
 #ifdef VHDL
 #include "Behavioural/include/Vhdl.h"
@@ -57,8 +53,5 @@
 #endif
 
-#ifdef POSITION
-  private   : Position                       * _position;
-#endif
-
+  public    : Component                      * _component;
   private   : Interfaces                     * _interfaces;
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_allocation.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_allocation.cpp	(revision 42)
@@ -17,22 +17,28 @@
   void RegisterFile_Monolithic::allocation (void)
   {
+    _component   = new Component ();
+
+    Entity * entity = _component->set_entity (_name                   
+					     ,"RegisterFile_Monolithic"
 #ifdef POSITION
-    _position   = new Position ();
-
-    Entity * entity = _position->set_entity (_name                    ,
-					     "RegisterFile_Monolithic",
-					     REGISTER                 );
+					     ,REGISTER                 
+#endif
+					      );
     
     _interfaces = entity->set_interfaces();
-#else
-    _interfaces = new Interfaces();
-#endif
 
     // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-    Interface * interface_ = _interfaces->set_interface("", IN  ,SOUTH, "Generalist interface");
-
-     in_CLOCK              = interface_->set_signal_clk              ("clock" ,1);
-     in_NRESET             = interface_->set_signal_in  <Tcontrol_t> ("nreset",1);
-
+    {
+      Interface * interface = _interfaces->set_interface(""
+#ifdef POSITION
+							 , IN
+							 ,SOUTH
+							 , "Generalist interface"
+#endif
+							 );
+      
+      in_CLOCK              = interface->set_signal_clk              ("clock" ,1);
+      in_NRESET             = interface->set_signal_in  <Tcontrol_t> ("nreset",1, RESET_VHDL_YES);
+    }
     // ~~~~~[ Interface : "read" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
@@ -44,10 +50,16 @@
     for (uint32_t i=0; i<_param._nb_port_read; i++)
       { 
-	Interface_fifo * interface_read = _interfaces->set_interface("read_"+toString(i), IN  ,WEST, "Interface Read");
+	Interface_fifo * interface = _interfaces->set_interface("read_"+toString(i)
+#ifdef POSITION
+								, IN  
+								,WEST
+								, "Interface Read"
+#endif
+								);
 
-	 in_READ_VAL     [i]  = interface_read->set_signal_valack_in        ("val"    , VAL);
-	out_READ_ACK     [i]  = interface_read->set_signal_valack_out       ("ack"    , ACK);
-	 in_READ_ADDRESS [i]  = interface_read->set_signal_in  <Taddress_t> ("address", static_cast<uint32_t>(log2(_param._nb_word)));
-	out_READ_DATA    [i]  = interface_read->set_signal_out <Tdata_t   > ("data"   , _param._size_word);
+	 in_READ_VAL     [i]  = interface->set_signal_valack_in        ("val"    , VAL);
+	out_READ_ACK     [i]  = interface->set_signal_valack_out       ("ack"    , ACK);
+	 in_READ_ADDRESS [i]  = interface->set_signal_in  <Taddress_t> ("address", static_cast<uint32_t>(log2(_param._nb_word)));
+	out_READ_DATA    [i]  = interface->set_signal_out <Tdata_t   > ("data"   , _param._size_word);
       }
 
@@ -61,10 +73,16 @@
     for (uint32_t i=0; i<_param._nb_port_write; i++)
       {
-	Interface_fifo * interface_write = _interfaces->set_interface("write_"+toString(i), IN  ,EAST, "Interface Write");
+	Interface_fifo * interface = _interfaces->set_interface("write_"+toString(i)
+#ifdef POSITION
+								, IN  
+								,EAST
+								, "Interface Write"
+#endif
+								);
 
-	 in_WRITE_VAL     [i]  = interface_write->set_signal_valack_in        ("val"    , VAL);
-	out_WRITE_ACK     [i]  = interface_write->set_signal_valack_out       ("ack"    , ACK);
-	 in_WRITE_ADDRESS [i]  = interface_write->set_signal_in  <Taddress_t> ("address", static_cast<uint32_t>(log2(_param._nb_word)));
-	 in_WRITE_DATA    [i]  = interface_write->set_signal_in  <Tdata_t   > ("data"   , _param._size_word);
+	 in_WRITE_VAL     [i]  = interface->set_signal_valack_in        ("val"    , VAL);
+	out_WRITE_ACK     [i]  = interface->set_signal_valack_out       ("ack"    , ACK);
+	 in_WRITE_ADDRESS [i]  = interface->set_signal_in  <Taddress_t> ("address", static_cast<uint32_t>(log2(_param._nb_word)));
+	 in_WRITE_DATA    [i]  = interface->set_signal_in  <Tdata_t   > ("data"   , _param._size_word);
       }
 
@@ -79,5 +97,5 @@
 
 #ifdef POSITION
-    _position->generate_file();
+    _component->generate_file();
 #endif
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_deallocation.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_deallocation.cpp	(revision 42)
@@ -17,4 +17,6 @@
   void RegisterFile_Monolithic::deallocation (void)
   {
+    delete _component;
+
     delete    in_CLOCK;
     delete    in_NRESET;
@@ -33,10 +35,4 @@
     // ----- Register
     delete [] reg_DATA;
-
-#ifdef POSITION
-    delete _position;
-#else
-    delete _interfaces;
-#endif
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/include/Select_Priority_Fixed.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/include/Select_Priority_Fixed.h	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/include/Select_Priority_Fixed.h	(revision 42)
@@ -22,9 +22,5 @@
 #include "Behavioural/Generic/Select/Select_Priority_Fixed/include/Statistics.h"
 #endif
-#ifdef POSITION
-#include "Behavioural/include/Position.h"
-#else
-#include "Behavioural/include/Interfaces.h"
-#endif
+#include "Behavioural/include/Component.h"
 #ifdef VHDL
 #include "Behavioural/include/Vhdl.h"
@@ -58,8 +54,5 @@
 #endif
 
-#ifdef POSITION
-  private   : Position                       * _position;
-#endif
-
+  private   : Component                      * _component;
   private   : Interfaces                     * _interfaces;
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_allocation.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_allocation.cpp	(revision 42)
@@ -19,22 +19,27 @@
     log_printf(FUNC,Select_Priority_Fixed,"allocation","Begin");
 
+    _component   = new Component ();
+
+    Entity * entity = _component->set_entity (_name                 
 #ifdef POSITION
-    _position   = new Position ();
-
-    Entity * entity = _position->set_entity (_name                  ,
-					     "Select_Priority_Fixed",
-					     COMBINATORY            );
+					     ,"Select_Priority_Fixed"
+					     ,COMBINATORY            
+#endif
+					      );
     
     _interfaces = entity->set_interfaces();
-#else
-    _interfaces = new Interfaces();
-#endif
 
     // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-    Interface_fifo * interface_ = _interfaces->set_interface("", IN  ,WEST, "Generalist interface");
+    Interface_fifo * interface = _interfaces->set_interface(""
+#ifdef POSITION
+							    ,IN  
+							    ,WEST
+							    ,"Generalist interface"
+#endif
+							    );
 
-     in_CLOCK        = interface_->set_signal_clk              ("clock" ,1, CLOCK_VHDL_NO);
-     in_NRESET       = interface_->set_signal_in  <Tcontrol_t> ("nreset",1);
+     in_CLOCK        = interface->set_signal_clk              ("clock" ,1, CLOCK_VHDL_NO);
+     in_NRESET       = interface->set_signal_in  <Tcontrol_t> ("nreset",1);
      in_VAL          = new SC_IN (Tcontrol_t)           * [_param._nb_entity];
     if (_param._encoding_one_hot)
@@ -43,13 +48,13 @@
     for (uint32_t i=0; i<_param._nb_entity; i++)
       {
-	 in_VAL [i]    = interface_->set_signal_in  <Tcontrol_t> ("val_"+toString(i),1);
+	 in_VAL [i]    = interface->set_signal_in  <Tcontrol_t> ("val_"+toString(i),1);
 	if (_param._encoding_one_hot)
-	out_ACK [i]    = interface_->set_signal_out <Tcontrol_t> ("ack_"+toString(i),1);
+	out_ACK [i]    = interface->set_signal_out <Tcontrol_t> ("ack_"+toString(i),1);
       }
 
     if (_param._encoding_compact)
       {
-	out_ENTITY     = interface_->set_signal_out <Tentity_t > ("entity"    , _param._size_entity);
-	out_ENTITY_ACK = interface_->set_signal_out <Tcontrol_t> ("entity_ack", 1);
+	out_ENTITY     = interface->set_signal_out <Tentity_t > ("entity"    , _param._size_entity);
+	out_ENTITY_ACK = interface->set_signal_out <Tcontrol_t> ("entity_ack", 1);
       }
 
@@ -57,5 +62,5 @@
 
 #ifdef POSITION
-    _position->generate_file();
+    _component->generate_file();
 #endif
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_deallocation.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_deallocation.cpp	(revision 42)
@@ -34,9 +34,6 @@
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
 
-#ifdef POSITION
-    delete _position;
-#else
-    delete _interfaces;
-#endif
+    delete _component;
+
     log_printf(FUNC,Select_Priority_Fixed,"deallocation","End");
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/src/test.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/src/test.cpp	(revision 42)
@@ -44,4 +44,5 @@
    *********************************************************************/
   sc_clock                                 CLOCK ("clock", 1.0, 0.5);
+  sc_signal <Tdirection_t>                 NRESET("nreset");
   sc_signal <Tdata_t     >                 SHIFTER_DATA_IN   [param._nb_port];
   sc_signal <Tshift_t    >                 SHIFTER_SHIFT     [param._nb_port];
@@ -61,4 +62,5 @@
 #if (defined(STATISTICS) || defined (VHDL_TESTBENCH))
   (*(_Shifter->in_CLOCK))        (CLOCK);
+  (*(_Shifter->in_NRESET))       (NRESET);
 #endif
   for (uint32_t i=0; i<param._nb_port; i++)
@@ -116,4 +118,6 @@
 
   sc_start(0);
+
+  NRESET.write(1);
   
   for (uint32_t x=0; x<6; x++)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/include/Shifter.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/include/Shifter.h	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/include/Shifter.h	(revision 42)
@@ -24,7 +24,5 @@
 #include "Behavioural/include/Vhdl.h"
 #endif
-#ifdef VHDL_TESTBENCH
-#include "Behavioural/include/Vhdl_Testbench.h"
-#endif
+#include "Behavioural/include/Component.h"
 
 using namespace std;
@@ -50,11 +48,12 @@
 #endif
 
-#ifdef VHDL_TESTBENCH
-  private   : Vhdl_Testbench                 * _vhdl_testbench;
-#endif
+  public    : Component                      * _component;
+  private   : Interfaces                     * _interfaces;
 
 #ifdef SYSTEMC
     // ~~~~~[ Interface ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   public    : SC_CLOCK                      *  in_CLOCK             ;
+  public    : SC_IN (Tcontrol_t)            *  in_NRESET            ;
+
     // Interface "shifter"
   public    : SC_IN (Tdata_t)              **  in_SHIFTER_DATA      ;
@@ -104,7 +103,7 @@
 #if VHDL				       
   public  : void     vhdl                      (void);
-  private : void     vhdl_port                 (Vhdl & vhdl);
-  private : void     vhdl_declaration          (Vhdl & vhdl);
-  private : void     vhdl_body                 (Vhdl & vhdl);
+  private : void     vhdl_port                 (Vhdl * & vhdl);
+  private : void     vhdl_declaration          (Vhdl * & vhdl);
+  private : void     vhdl_body                 (Vhdl * & vhdl);
 #endif					       
 #ifdef STATISTICS
@@ -113,7 +112,5 @@
 					       
 #ifdef VHDL_TESTBENCH			       
-  private : void     vhdl_testbench            (Vhdl_Testbench & vhdl_testbench);
-  private : void     vhdl_testbench_port       (Vhdl_Testbench & vhdl_testbench);
-  private : void     vhdl_testbench_transition (Vhdl_Testbench & vhdl_testbench);
+  private : void     vhdl_testbench_transition (void);
 #endif
 
